#!/bin/sh
#
# bbdef.sh
#
# BIG BROTHER DEFINITIONS AREA
#
# (c) Copyright Quest Software, Inc.  1997-2003  All rights reserved.
#

# OS TYPE
BBOSTYPE="redhat"
export BBOSTYPE

# BB USER
BBUSER="bigbro"
export BBUSER

#
# What is default port for BB ?
#
BBPORT=1984
export BBPORT

#
# NEW FOR 1.04... DISPLAY FULLY QUALIFED DOMAIN NAMES?
# i.e. aaa.bbb.com instead of just aaa
#
# FQDN="TRUE"		# YES...

FQDN="TRUE"

#
# PREVENT BB TO RUN AS root ?
#
STOPROOT="TRUE"
export STOPROOT

#
# WHERE tmp FILES LIVE - THIS IS GOOD FOR SECURITY
# THANKS TO Alan Cox (alan@cymru.net)
#

BBTMP="$BBHOME/tmp"
export BBTMP

#
# LOCATION OF BBOUT FILE
#
BBOUT="$BBHOME/BBOUT"
export BBOUT

#
# LOCATION OF PIDs FILE
#
BBPID="$BBTMP/BBPID"
export BBPID

#
# Default colors to send notification messages on
#
PAGELEVELS="red purple"                 #
                                        # purple is always sent by the
                                        # BBDISPLAY. Clients shouldn't
                                        # send purple
export PAGELEVELS                       # Will be overidden in bbinc.sh
                                        # with values found in
                                        # etc/bbwarnsetup.cfg

#
# EXECUTE LOCAL SCRIPTS FROM HERE...
# SCRIPTS SHOULD LIVE IN $BBHOME/ext DIRECTORY
# BBEXT CONTAINS THE FILENAMES TO EXECUTE
# SEPERATE THE SCRIPTS WITH A SPACE:  BBEXT="ext1.sh ext2.sh"
# IT IS PREFERABLE THAT YOU USE THE etc/bb-bbexttab FILE
# INSTEAD OF THIS. IT IS KEPT FOR BACKWARD COMPATIBILITY
# 
BBEXT=""
BBDEFSLEEP=300                  # HOW OFTEN TO RUN EXTERNAL SCRIPTS (IN SECONDS)
export BBEXT BBDEFSLEEP

#
# What's the largest message size that can be sent out
# This value is used by the bb-combo.sh script
# It should be the same value as in src/bb.h
#
MAXLINE=10240
export MAXLINE

#
# configuration variables associated with the combo message
#
DOCOMBO=TRUE		# Do we use the combo message ?
MAXCOMBOMSGS=999	# Maximum status logs in a single combo message
MAXCOMBOTTL=120		# combo workfile maximum Time to live, in seconds
export DOCOMBO MAXCOMBOMSGS MAXCOMBOTTL


if [ -x "${BBHOME}/bin/bbd" ]
then
	# We're a server
	. ${BBHOME}/etc/bbdef-server.sh
else
	# We're a client
	. ${BBHOME}/etc/bbdef-client.sh
fi

. ${BBHOME}/etc/bbsys.sh		# INCLUDE SYSTEM DEFINITIONS
. ${BBHOME}/etc/bbinc.sh		# INCLUDE BB DEFINITIONS

export FQDN MSGFILE DF LYNX
