#!/usr/bin/perl

#$debug     = 1;

# if this is run by bb, set sudo
$sudo = "";
#$sudo = "/usr/bin/sudo";

$test      = 'raid';		
#$twbin	   = "/usr/local/sbin/tw_cli";
$twbin	   = "$sudo /usr/sbin/storcli64 /c0 show";
$errbin     = "$sudo /usr/sbin/storcli64 /c0/eall/sall show all";


#----------------------------
# BB Colors
#----------------------------
%ColorCode = (
  'clear'  => 0,
  'green'  => 1,
  'yellow' => 2,
  'red'    => 3,
  'purple' => 4,
  0 => 'clear',
  1 => 'green',
  2 => 'yellow',
  3 => 'red',
  4 => 'purple',
);

#print "start\n";

#print "main\n";
#----------------------------
# main loop
#----------------------------

%controllers = ();
push(@{$controllers{0}},0);
# add additional controllers
#push(@{$controllers{0}},1);

$bbcolor = 0;
$bbhost = `cd $ENV{BBHOME}; cat etc/bbaliasname`;
chomp $bbhost;
$bbhost =~ s/\s+$//;
print "hostname post +$bbhost+\n" if $debug;

$status .= "\n<FONT SIZE=+2><b>Summary Info</b></FONT>\n";
for $controller (sort {@{$controllers{$b}} <=> @{$controllers{$a}}} keys %controllers) {
  foreach $unit (@{$controllers{$controller}}) {
    @checkout = qx($twbin info c$controller u$unit);
    my $rbcnt = 0;
    my @rbarray;
    print "running command $twbin\n" if $debug;
    @checkout = qx($twbin);
    foreach (@checkout) {
      $line = $_;
      chomp;
      print "Got: $line\n" if $debug;
      $status .= $line;
      if ($line =~ /Optl/ || $line =~ /Onln/) {
	 SetColor('green');
      } elsif ($line =~ / Frgn /) {
	 SetColor('red');
      } elsif ($line =~ / Msng /) {
	 SetColor('red');
      } elsif ($line =~ / Pdgd /) {
	 SetColor('red');
      } elsif ($line =~ / Dgrd /) {
	 SetColor('red');
      } elsif ($line =~ / dgrd /) {
	 SetColor('red');
      } elsif ($line =~ / Failed /) {
	 SetColor('red');
      } elsif ($line =~ / Ubad /) {
	 SetColor('red');
      } elsif ($line =~ / Offln /) {
	 SetColor('red');
      } else {
	 SetColor('green');
      }
      if ($line =~ / Rbld /) {
         my $tstr;
         chomp($tstr = $line);
         $tstr =~ s/ .*//;
	 if (length $tstr) {
             $rbcnt = $rbcnt+1;
             $rbarray[$rbcnt] = $tstr;
#print "Increment Cnt: $rbcnt value: ($rbarray[$rbcnt])\n";
         } 
      }

    }	
  }
}
if ( $rbcnt ) {
	my $rbinfo = "\n\nRebuilding Disk:\n";
	while ( $rbcnt ){
#print "looking for: ($rbarray[$rbcnt])\n";
		$enclo = $rbarray[$rbcnt];
		$enclo =~ s/:.*//;
		$disk = $rbarray[$rbcnt];
		$disk =~ s/.*://;
#print "Enclo: $enclo  Disk: $disk\n";
		my $detail = "/c0/e" . $enclo . "/s" . $disk;
#print "detail: $detail\n";
		my @perc;
    		@perc = qx($sudo /usr/sbin/storcli64 $detail show rebuild);
		foreach (@perc) {
			$line = $_;
#print "got out: $line\n";
			if ( $line =~ /$detail/ ) {
#print "adding ($line)\n";
				$rbinfo .= $line;
			}
		}
		$rbcnt = $rbcnt - 1;
	}
	$status = $rbinfo . "\n" . $status;
}

# drive error check
@checkerr = qx($errbin);
$keep = 0;
$errwarn = 0;
$drivewarn = 0;
$drivedata = "";
$status .= "\nDrive Warnings:\n\n";
foreach (@checkerr) {
  chomp;
  $line = $_;
  print "Got: $line\n" if $debug;
  # data block begins with "Drive /c0/e32/c0 State :" for example
  if ($line =~ /^Drive .* State/) {
    $keep = 1;
    print "keep=1\n" if $debug;
    $drivedata .= "\n";
  }
  if ($keep && $line ne '') {
    $drivedata .= $line . "\n";;
    print "added $line\n" if $debug;
    if ($line =~ /Count/) {
      @entry = split(/ = /, $line);
      print "Counter: ".$entry[0]." has ".$entry[1]."\n" if $debug;
      if ($entry[1] > 100) {
        # errors found
        print "Error found\n" if $debug;
	SetColor('yellow');
        $errwarn = 1;
        $drivewarn = 1;
      }
    }
  } else {
    # stop collecting data when you reach a blank line
    $keep = 0;
    if ($drivedata ne '' && $drivewarn) {
       # we collected data about a 
       $status .= $drivedata;
    }
    $drivedata = "";
    $drivewarn = 0;
  }
}
if ($errwarn) {
  $status = "\n\nDisk Errors Found!\n\n" . $status;
} else {
   $status .= "No Warnings\n";
}

#print "do report\n";
ReportBB ($bbhost, $ColorCode{$bbcolor}, $status);
#print "end report\n";
#----------------------------
# set the colors
#----------------------------
sub SetColor {
  my ($setcolor) = @_;
  if ($ColorCode{$setcolor} > $bbcolor) {
    $bbcolor = $ColorCode{$setcolor};
  }
}
#----------------------------
# send the result to bbd
#----------------------------
sub ReportBB {

  my($HostName, $color, $status) = @_ ;

  $HostName =~ s/\./,/g;
  $color    = lc($color);
  my $Cmd   = '/opt/bbc/bin/bb 149.127.2.2 '
            . ' "status '
            . $HostName       . '.'
            . $test           . ' '
            . $color          . ' ' 
            . localtime(time) . ' '
            . $status         . '"';
  print "$Cmd\n" if $debug;
  `$Cmd`         if ! $debug;
}

